
//	This is the actual (DEMO) filter-function
//	which is called by the main_driver
//	after the file_IO is completed by the 
//	demo_IO method

#include <iostream.h>

int getTotal1D_size(int, int*);
void localFilter(unsigned char *, int, int *);

void myDemoFilter(unsigned char *myArray, int _number_dims, int *myDims)
{	
	localFilter(myArray, _number_dims, myDims);

	return;
}

void localFilter(unsigned char *myArray, int _number_dims, int *myDims)
{	cout << "Inside::myDemoFilter::localFilter:\t" << " " << endl;
	// get input data in a new array
	int size = getTotal1D_size(_number_dims, myDims);
	unsigned char *local_array;
	local_array = new unsigned char[size];
	
	// change values/filter data
	for (int i=0; i < size; i++)
		local_array[i] = myArray[size-i];

	// save out new filtered values at the input array location
	for (int i=0; i < size; i++)
		myArray[i] = local_array[i];

	delete [] local_array;
    	return;
}

int getTotal1D_size(int number_dims, int* dims)
{	int size = 1;
	for (int i = 0; i < number_dims; i++)
		size *= dims[i];
	return size;
}
